PATH:
usr
/
bin
#!/usr/bin/bash set -ue # Copyright (C) 2017-2024 MariaDB # Copyright (C) 2010-2022 Codership Oy # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; version 2 of the License. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program; see the file COPYING. If not, write to the # Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston # MA 02110-1335 USA. # This is a reference script for rsync-based state snapshot transfer. . $(dirname "$0")/wsrep_sst_common wsrep_check_programs rsync RSYNC_REAL_PID=0 # rsync process id STUNNEL_REAL_PID=0 # stunnel process id MODULE="${WSREP_SST_OPT_MODULE:-rsync_sst}" RSYNC_PID="$DATA/$MODULE.pid" RSYNC_CONF="$DATA/$MODULE.conf" STUNNEL_CONF="$DATA/stunnel.conf" STUNNEL_PID="$DATA/stunnel.pid" MAGIC_FILE="$DATA/rsync_sst_complete" cleanup_joiner() { # Since this is invoked just after exit NNN local estatus=$? if [ $estatus -ne 0 ]; then wsrep_log_error "Cleanup after exit with status: $estatus" elif [ -z "${coords:-}" ]; then estatus=32 wsrep_log_error "Failed to get current position" fi local failure=0 [ "$(pwd)" != "$OLD_PWD" ] && cd "$OLD_PWD" wsrep_log_info "Joiner cleanup: rsync PID=$RSYNC_REAL_PID," \ "stunnel PID=$STUNNEL_REAL_PID" if [ -n "$STUNNEL" ]; then if cleanup_pid $STUNNEL_REAL_PID "$STUNNEL_PID" "$STUNNEL_CONF"; then if [ $RSYNC_REAL_PID -eq 0 ]; then if [ -r "$RSYNC_PID" ]; then RSYNC_REAL_PID=$(cat "$RSYNC_PID" 2>/dev/null || :) if [ -z "$RSYNC_REAL_PID" ]; then RSYNC_REAL_PID=0 fi fi fi else wsrep_log_warning "stunnel cleanup failed." failure=1 fi fi if [ $failure -eq 0 ]; then if cleanup_pid $RSYNC_REAL_PID "$RSYNC_PID" "$RSYNC_CONF"; then [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" || : [ -f "$BINLOG_TAR_FILE" ] && rm -f "$BINLOG_TAR_FILE" || : else wsrep_log_warning "rsync cleanup failed." fi fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then wsrep_cleanup_progress_file fi [ -f "$SST_PID" ] && rm -f "$SST_PID" || : wsrep_log_info "Joiner cleanup done." exit $estatus } check_pid_and_port() { local pid_file="$1" local pid=$2 local addr="$3" local port="$4" local utils='rsync|stunnel' local port_info local final if ! check_port $pid "$port" "$utils"; then if [ $ss_available -ne 0 -o $sockstat_available -ne 0 ]; then if [ $ss_available -ne 0 ]; then port_info=$($socket_utility $ss_opts -t "( sport = :$port )" 2>/dev/null | \ grep -E '[[:space:]]users:[[:space:]]?\(' | \ grep -o -E "([^[:space:]]+[[:space:]]+){4}[^[:space:]]+" || :) else if [ $sockstat_available -gt 1 ]; then # The sockstat command on FreeBSD does not return # the connection state without special option, but # it supports filtering by connection state. # Additionally, the sockstat utility on FreeBSD # produces an one extra column: port_info=$($socket_utility $sockstat_opts "$port" 2>/dev/null | \ grep -o -E "([^[:space:]]+[[:space:]]+){5}[^[:space:]]+" || :) else port_info=$($socket_utility $sockstat_opts "$port" 2>/dev/null | \ grep -E '[[:space:]]LISTEN([[:space:]]|$)' | \ grep -o -E "([^[:space:]]+[[:space:]]+){4}[^[:space:]]+" || :) fi fi final='$' else port_info=$($socket_utility $lsof_opts -i ":$port" 2>/dev/null | \ grep -w -F '(LISTEN)' || :) final='[[:space:]]' fi local busy=0 if [ -n "$port_info" ]; then local address='(\*|[0-9a-fA-F]*(:[0-9a-fA-F]*){1,7}|[0-9]+(\.[0-9]+){3})' local filter="[[:space:]]($address|\\[$address\\])(%[^:]+)?:$port$final" echo "$port_info" | grep -q -E "$filter" && busy=1 fi if [ $busy -eq 0 ]; then if ! ps -p $pid >/dev/null 2>&1; then wsrep_log_error \ "the rsync or stunnel daemon (PID: $pid)" \ "terminated unexpectedly." exit 16 # EBUSY fi return 1 fi local rc=0 check_port $pid "$port" "$utils" || rc=$? if [ $rc -eq 16 ]; then # We will ignore the return code EBUSY, which indicates # a failed attempt to run the utility for retrieving # socket information (on some systems): return 1 elif [ $rc -ne 0 ]; then wsrep_log_error "rsync or stunnel daemon port '$port'" \ "has been taken by another program" exit 16 # EBUSY fi fi check_pid "$pid_file" && [ $CHECK_PID -eq $pid ] } get_binlog if [ -n "$WSREP_SST_OPT_BINLOG" ]; then binlog_dir=$(dirname "$WSREP_SST_OPT_BINLOG") binlog_base=$(basename "$WSREP_SST_OPT_BINLOG") fi BINLOG_TAR_FILE="$DATA_DIR/wsrep_sst_binlog.tar" ar_log_dir="$DATA_DIR" ib_log_dir="$DATA_DIR" ib_home_dir="$DATA_DIR" ib_undo_dir="$DATA_DIR" encgroups='--mysqld|sst' check_server_ssl_config SSTKEY="$tkey" SSTCERT="$tpem" SSTCA="$tcert" SSTCAP="$tcap" SSLMODE=$(parse_cnf "$encgroups" 'ssl-mode' | tr '[[:lower:]]' '[[:upper:]]') if [ -z "$SSLMODE" ]; then # Implicit verification if CA is set and the SSL mode # is not specified by user: if [ -n "$SSTCA$SSTCAP" ]; then STUNNEL_BIN=$(commandex 'stunnel') if [ -n "$STUNNEL_BIN" ]; then SSLMODE='VERIFY_CA' fi # Require SSL by default if SSL key and cert are present: elif [ -n "$SSTKEY" -a -n "$SSTCERT" ]; then SSLMODE='REQUIRED' fi else case "$SSLMODE" in 'VERIFY_IDENTITY'|'VERIFY_CA'|'REQUIRED'|'DISABLED') ;; *) wsrep_log_error "Unrecognized ssl-mode option: '$SSLMODE'" exit 22 # EINVAL ;; esac fi if [ -n "$SSTKEY" -a -n "$SSTCERT" ]; then verify_cert_matches_key "$SSTCERT" "$SSTKEY" fi CAFILE_OPT="" CAPATH_OPT="" if [ -n "$SSTCA$SSTCAP" ]; then if [ -n "$SSTCA" ]; then CAFILE_OPT="CAfile = $SSTCA" fi if [ -n "$SSTCAP" ]; then CAPATH_OPT="CApath = $SSTCAP" fi if [ -n "$SSTCERT" ]; then verify_ca_matches_cert "$SSTCERT" "$SSTCA" "$SSTCAP" fi fi VERIFY_OPT="" CHECK_OPT="" CHECK_OPT_LOCAL="" if [ "${SSLMODE#VERIFY}" != "$SSLMODE" ]; then if [ "$SSLMODE" = 'VERIFY_IDENTITY' ]; then VERIFY_OPT='verifyPeer = yes' else VERIFY_OPT='verifyChain = yes' fi if [ -z "$SSTCA$SSTCAP" ]; then wsrep_log_error "Can't have ssl-mode='$SSLMODE' without CA file or path" exit 22 # EINVAL fi if [ -n "$WSREP_SST_OPT_REMOTE_USER" ]; then CHECK_OPT="checkHost = $WSREP_SST_OPT_REMOTE_USER" elif [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then # check if the address is an ip-address (v4 or v6): if echo "$WSREP_SST_OPT_HOST_UNESCAPED" | \ grep -q -E '^([0-9]+(\.[0-9]+){3}|[0-9a-fA-F]*(:[0-9a-fA-F]*){1,7})$' then CHECK_OPT="checkIP = $WSREP_SST_OPT_HOST_UNESCAPED" else CHECK_OPT="checkHost = $WSREP_SST_OPT_HOST" fi if is_local_ip "$WSREP_SST_OPT_HOST_UNESCAPED"; then CHECK_OPT_LOCAL='checkHost = localhost' fi fi fi STUNNEL="" if [ -n "$SSLMODE" -a "$SSLMODE" != 'DISABLED' ]; then if [ -z "${STUNNEL_BIN+x}" ]; then STUNNEL_BIN=$(commandex 'stunnel') fi if [ -n "$STUNNEL_BIN" ]; then wsrep_log_info "Using stunnel for SSL encryption: CA: '$SSTCA'," \ "CAPATH='$SSTCAP', ssl-mode='$SSLMODE'" STUNNEL="$STUNNEL_BIN $STUNNEL_CONF" fi fi readonly SECRET_TAG='secret' readonly BYPASS_TAG='bypass' wait_previous_sst # give some time for stunnel from the previous SST to complete: check_round=0 while check_pid "$STUNNEL_PID" 1 "$STUNNEL_CONF"; do wsrep_log_info "Lingering stunnel daemon found at startup," \ "waiting for it to exit" check_round=$(( check_round+1 )) if [ $check_round -eq 30 ]; then wsrep_log_error "stunnel daemon still running..." exit 114 # EALREADY fi sleep 1 done # give some time for rsync from the previous SST to complete: check_round=0 while check_pid "$RSYNC_PID" 1 "$RSYNC_CONF"; do wsrep_log_info "Lingering rsync daemon found at startup," \ "waiting for it to exit" check_round=$(( check_round+1 )) if [ $check_round -eq 30 ]; then wsrep_log_error "rsync daemon still running..." exit 114 # EALREADY fi sleep 1 done [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" [ -f "$BINLOG_TAR_FILE" ] && rm -f "$BINLOG_TAR_FILE" RC=0 if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then if [ -n "$STUNNEL" ]; then cat << EOF > "$STUNNEL_CONF" key = $SSTKEY cert = $SSTCERT ${CAFILE_OPT} ${CAPATH_OPT} foreground = yes pid = $STUNNEL_PID debug = warning client = yes connect = $WSREP_SST_OPT_HOST_UNESCAPED:$WSREP_SST_OPT_PORT TIMEOUTclose = 0 ${VERIFY_OPT} ${CHECK_OPT} ${CHECK_OPT_LOCAL} EOF fi if [ $WSREP_SST_OPT_BYPASS -eq 0 ]; then FLUSHED="$DATA/tables_flushed" ERROR="$DATA/sst_error" [ -f "$FLUSHED" ] && rm -f "$FLUSHED" [ -f "$ERROR" ] && rm -f "$ERROR" echo 'flush tables' # Wait for : # (a) Tables to be flushed, AND # (b) Cluster state ID & wsrep_gtid_domain_id to be written to the file, OR # (c) ERROR file, in case flush tables operation failed. while [ ! -r "$FLUSHED" ] || \ ! grep -q -F ':' -- "$FLUSHED" do # Check whether ERROR file exists. if [ -f "$ERROR" ]; then # Flush tables operation failed. rm "$ERROR" exit 255 fi sleep 0.2 done STATE=$(cat "$FLUSHED") rm "$FLUSHED" sync wsrep_log_info "Tables flushed" if [ -n "$WSREP_SST_OPT_BINLOG" ]; then # Change the directory to binlog base (if possible): cd "$DATA" # Let's check the existence of the file with the index: if [ -f "$WSREP_SST_OPT_BINLOG_INDEX" ]; then # Let's read the binlog index: max_binlogs=$(parse_cnf "$encgroups" 'sst-max-binlogs' 1) if [ $max_binlogs -ge 0 ]; then binlog_files="" if [ $max_binlogs -gt 0 ]; then binlog_files=$(tail -n $max_binlogs \ "$WSREP_SST_OPT_BINLOG_INDEX") fi else binlog_files=$(cat "$WSREP_SST_OPT_BINLOG_INDEX") fi if [ -n "$binlog_files" ]; then # Preparing binlog files for transfer: wsrep_log_info "Preparing binlog files for transfer:" tar_type=0 if tar --help 2>/dev/null | grep -qw -F -- '--transform'; then tar_type=1 elif tar --version 2>/dev/null | grep -qw -E '^bsdtar'; then tar_type=2 fi if [ $tar_type -eq 2 ]; then echo "$binlog_files" >&2 fi if [ $tar_type -ne 0 ]; then # Preparing list of the binlog file names: echo "$binlog_files" | { binlogs="" while read bin_file || [ -n "$bin_file" ]; do [ ! -f "$bin_file" ] && continue if [ -n "$BASH_VERSION" ]; then first="${bin_file:0:1}" else first=$(echo "$bin_file" | cut -c1) fi if [ "$first" = '-' -o "$first" = '@' ]; then bin_file="./$bin_file" fi binlogs="$binlogs${binlogs:+ }'$bin_file'" done if [ -n "$binlogs" ]; then if [ $tar_type -eq 1 ]; then tar_options="--transform='s/^.*\///g'" else # bsdtar handles backslash incorrectly: tar_options="-s '?^.*/??g'" fi eval tar -P $tar_options \ -cvf "'$BINLOG_TAR_FILE'" $binlogs >&2 fi } else tar_options='-cvf' echo "$binlog_files" | \ while read bin_file || [ -n "$bin_file" ]; do [ ! -f "$bin_file" ] && continue bin_dir=$(dirname "$bin_file") bin_base=$(basename "$bin_file") if [ -n "$BASH_VERSION" ]; then first="${bin_base:0:1}" else first=$(echo "$bin_base" | cut -c1) fi if [ "$first" = '-' -o "$first" = '@' ]; then bin_base="./$bin_base" fi if [ -n "$bin_dir" -a "$bin_dir" != '.' -a \ "$bin_dir" != "$DATA_DIR" ] then tar $tar_options "$BINLOG_TAR_FILE" \ -C "$bin_dir" "$bin_base" >&2 else tar $tar_options "$BINLOG_TAR_FILE" \ "$bin_base" >&2 fi tar_options='-rvf' done fi fi fi cd "$OLD_PWD" fi # Use deltaxfer only for WAN: WHOLE_FILE_OPT="" if [ "${WSREP_METHOD%_wan}" = "$WSREP_METHOD" ]; then WHOLE_FILE_OPT='--whole-file' fi # Old filter - include everything except selected # FILTER=(--exclude '*.err' --exclude '*.pid' --exclude '*.sock' \ # --exclude '*.conf' --exclude core --exclude 'galera.*' \ # --exclude grastate.txt --exclude '*.pem' \ # --exclude '*.[0-9][0-9][0-9][0-9][0-9][0-9]' --exclude '*.index') # New filter - exclude everything except dirs (schemas) and innodb files FILTER="-f '- /lost+found' -f '- /.zfs' -f '- /.fseventsd' -f '- /.Trashes' -f '- /.pid' -f '- /.conf' -f '- /.snapshot/' -f '+ /wsrep_sst_binlog.tar' -f '- $ib_home_dir/ib_lru_dump' -f '- $ib_home_dir/ibdata*' -f '- $ib_undo_dir/undo*' -f '- $ib_log_dir/ib_logfile[0-9]*' -f '- $ar_log_dir/aria_log_control' -f '- $ar_log_dir/aria_log.*' -f '+ /*/' -f '- /*'" # first, the normal directories, so that we can detect # incompatible protocol: eval rsync ${STUNNEL:+"--rsh='$STUNNEL'"} \ --owner --group --perms --links --specials \ --ignore-times --inplace --dirs --delete --quiet \ $WHOLE_FILE_OPT $FILTER "'$DATA/'" \ "'rsync://$WSREP_SST_OPT_ADDR'" >&2 || RC=$? if [ $RC -ne 0 ]; then wsrep_log_error "rsync returned code $RC:" case $RC in 12) RC=71 # EPROTO wsrep_log_error \ "rsync server on the other end has incompatible" \ "protocol. Make sure you have the same version of" \ "rsync on all nodes." ;; 22) RC=12 # ENOMEM ;; *) RC=255 # unknown error ;; esac exit $RC fi wsrep_log_info "Transfer of normal directories done" if [ -d "$ib_home_dir" ]; then # Transfer InnoDB data files rsync ${STUNNEL:+--rsh="$STUNNEL"} \ --owner --group --perms --links --specials \ --ignore-times --inplace --dirs --delete --quiet \ $WHOLE_FILE_OPT -f '+ /ibdata*' -f '+ /ib_lru_dump' \ -f '- **' "$ib_home_dir/" \ "rsync://$WSREP_SST_OPT_ADDR-data_dir" >&2 || RC=$? if [ $RC -ne 0 ]; then wsrep_log_error "rsync innodb_data_home_dir returned code $RC:" exit 255 # unknown error fi wsrep_log_info "Transfer of InnoDB data files done" fi if [ -d "$ib_log_dir" ]; then # second, we transfer InnoDB log files rsync ${STUNNEL:+--rsh="$STUNNEL"} \ --owner --group --perms --links --specials \ --ignore-times --inplace --dirs --delete --quiet \ $WHOLE_FILE_OPT -f '+ /ib_logfile[0-9]*' \ -f '- **' "$ib_log_dir/" \ "rsync://$WSREP_SST_OPT_ADDR-log_dir" >&2 || RC=$? if [ $RC -ne 0 ]; then wsrep_log_error "rsync innodb_log_group_home_dir returned code $RC:" exit 255 # unknown error fi wsrep_log_info "Transfer of InnoDB log files done" fi if [ "$ib_undo_dir" ]; then # third, we transfer InnoDB undo logs rsync ${STUNNEL:+--rsh="$STUNNEL"} \ --owner --group --perms --links --specials \ --ignore-times --inplace --dirs --delete --quiet \ $WHOLE_FILE_OPT -f '+ /undo*' \ -f '- **' "$ib_undo_dir/" \ "rsync://$WSREP_SST_OPT_ADDR-undo_dir" >&2 || RC=$? if [ $RC -ne 0 ]; then wsrep_log_error "rsync innodb_undo_dir returned code $RC:" exit 255 # unknown error fi wsrep_log_info "Transfer of InnoDB undo logs done" fi if [ "$ar_log_dir" ]; then # fourth, we transfer Aria logs rsync ${STUNNEL:+--rsh="$STUNNEL"} \ --owner --group --perms --links --specials \ --ignore-times --inplace --dirs --delete --quiet \ $WHOLE_FILE_OPT -f '+ /aria_log_control' -f '+ /aria_log.*' \ -f '- **' "$ar_log_dir/" \ "rsync://$WSREP_SST_OPT_ADDR-aria_log" >&2 || RC=$? if [ $RC -ne 0 ]; then wsrep_log_error "rsync aria_log_dir_path returned code $RC:" exit 255 # unknown error fi wsrep_log_info "Transfer of Aria logs done" fi # then, we parallelize the transfer of database directories, # use '.' so that path concatenation works: backup_threads=$(parse_cnf '--mysqld|sst' 'backup-threads') if [ -z "$backup_threads" ]; then get_proc backup_threads=$nproc fi cd "$DATA" findopt='-L' [ "$OS" = 'FreeBSD' ] && findopt="$findopt -E" find $findopt . -maxdepth 1 -mindepth 1 -type d -not -name 'lost+found' \ -not -name '.zfs' -not -name .snapshot -print0 \ | xargs -I{} -0 -P $backup_threads \ rsync ${STUNNEL:+--rsh="$STUNNEL"} \ --owner --group --perms --links --specials --ignore-times \ --inplace --recursive --delete --quiet $WHOLE_FILE_OPT \ -f '- $ib_home_dir/ib_lru_dump' \ -f '- $ib_home_dir/ibdata*' \ -f '- $ib_undo_dir/undo*' \ -f '- $ib_log_dir/ib_logfile[0-9]*' \ -f '- $ar_log_dir/aria_log_control' \ -f '- $ar_log_dir/aria_log.*' \ "$DATA/{}/" \ "rsync://$WSREP_SST_OPT_ADDR/{}" >&2 || RC=$? cd "$OLD_PWD" if [ $RC -ne 0 ]; then wsrep_log_error "find/rsync returned code $RC:" exit 255 # unknown error fi wsrep_log_info "Transfer of data done" [ -f "$BINLOG_TAR_FILE" ] && rm "$BINLOG_TAR_FILE" else # BYPASS wsrep_log_info "Bypassing state dump." # Store donor's wsrep GTID (state ID) and wsrep_gtid_domain_id # (separated by a space). STATE="$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" fi wsrep_log_info "Sending continue to donor" echo 'continue' # now server can resume updating data echo "$STATE" > "$MAGIC_FILE" if [ -n "$WSREP_SST_OPT_REMOTE_PSWD" ]; then # Let joiner know that we know its secret echo "$SECRET_TAG $WSREP_SST_OPT_REMOTE_PSWD" >> "$MAGIC_FILE" fi if [ $WSREP_SST_OPT_BYPASS -ne 0 ]; then echo "$BYPASS_TAG" >> "$MAGIC_FILE" fi rsync ${STUNNEL:+--rsh="$STUNNEL"} \ --archive --quiet --checksum "$MAGIC_FILE" \ "rsync://$WSREP_SST_OPT_ADDR" >&2 || RC=$? rm "$MAGIC_FILE" if [ $RC -ne 0 ]; then wsrep_log_error "rsync $MAGIC_FILE returned code $RC:" exit 255 # unknown error fi echo "done $STATE" if [ -n "$STUNNEL" ]; then rm "$STUNNEL_CONF" [ -f "$STUNNEL_PID" ] && rm "$STUNNEL_PID" fi else # joiner check_sockets_utils create_dirs ADDR="$WSREP_SST_OPT_HOST" RSYNC_PORT="$WSREP_SST_OPT_PORT" RSYNC_ADDR="$WSREP_SST_OPT_HOST" RSYNC_ADDR_UNESCAPED="$WSREP_SST_OPT_HOST_UNESCAPED" trap cleanup_joiner EXIT touch "$SST_PROGRESS_FILE" if [ -n "${MYSQL_TMP_DIR:-}" ]; then SILENT="log file = $MYSQL_TMP_DIR/rsyncd.log" else SILENT="" fi cat << EOF > "$RSYNC_CONF" pid file = $RSYNC_PID use chroot = no read only = no timeout = 300 $SILENT [$MODULE] path = $DATA exclude = .zfs [$MODULE-log_dir] path = $ib_log_dir [$MODULE-data_dir] path = $ib_home_dir [$MODULE-undo_dir] path = $ib_undo_dir [$MODULE-aria_log] path = $ar_log_dir EOF # If the IP is local, listen only on it: if is_local_ip "$RSYNC_ADDR_UNESCAPED"; then RSYNC_EXTRA_ARGS="--address $RSYNC_ADDR_UNESCAPED" STUNNEL_ACCEPT="$RSYNC_ADDR_UNESCAPED:$RSYNC_PORT" else # Not local, possibly a NAT, listen on all interfaces: RSYNC_EXTRA_ARGS="" STUNNEL_ACCEPT="$RSYNC_PORT" # Overwrite address with all: RSYNC_ADDR='*' fi if [ -z "$STUNNEL" ]; then rsync --daemon --no-detach --port "$RSYNC_PORT" \ --config "$RSYNC_CONF" $RSYNC_EXTRA_ARGS & RSYNC_REAL_PID=$! TRANSFER_REAL_PID=$RSYNC_REAL_PID TRANSFER_PID="$RSYNC_PID" else # Let's check if the path to the config file contains a space? RSYNC_BIN=$(commandex 'rsync') if [ "${RSYNC_CONF#* }" = "$RSYNC_CONF" ]; then cat << EOF > "$STUNNEL_CONF" key = $SSTKEY cert = $SSTCERT ${CAFILE_OPT} ${CAPATH_OPT} foreground = yes pid = $STUNNEL_PID debug = warning client = no ${VERIFY_OPT} ${CHECK_OPT} ${CHECK_OPT_LOCAL} [rsync] accept = $STUNNEL_ACCEPT exec = $RSYNC_BIN execargs = rsync --server --daemon --config=$RSYNC_CONF . EOF else # The path contains a space, so we will run it via # shell with "eval" command: export RSYNC_CMD="eval '$RSYNC_BIN' --server --daemon --config='$RSYNC_CONF' ." cat << EOF > "$STUNNEL_CONF" key = $SSTKEY cert = $SSTCERT ${CAFILE_OPT} ${CAPATH_OPT} foreground = yes pid = $STUNNEL_PID debug = warning client = no ${VERIFY_OPT} ${CHECK_OPT} ${CHECK_OPT_LOCAL} [rsync] accept = $STUNNEL_ACCEPT exec = $SHELL execargs = $SHELL -c \$RSYNC_CMD EOF fi stunnel "$STUNNEL_CONF" & STUNNEL_REAL_PID=$! TRANSFER_REAL_PID=$STUNNEL_REAL_PID TRANSFER_PID="$STUNNEL_PID" fi if [ "${SSLMODE#VERIFY}" != "$SSLMODE" ]; then # backward-incompatible behavior: CN="" if [ -n "$SSTCERT" ]; then CN=$(openssl_getCN "$SSTCERT") fi MY_SECRET="$(wsrep_gen_secret)" # Add authentication data to address ADDR="$CN:$MY_SECRET@$WSREP_SST_OPT_HOST" else MY_SECRET="" # for check down in recv_joiner() fi until check_pid_and_port "$TRANSFER_PID" $TRANSFER_REAL_PID \ "$RSYNC_ADDR_UNESCAPED" "$RSYNC_PORT" do sleep 0.2 done echo "ready $ADDR:$RSYNC_PORT/$MODULE" # wait for SST to complete by monitoring magic file while [ ! -r "$MAGIC_FILE" ] && check_pid "$TRANSFER_PID" && \ ps -p $WSREP_SST_OPT_PARENT >/dev/null 2>&1 do sleep 1 done if ! ps -p $WSREP_SST_OPT_PARENT >/dev/null 2>&1; then wsrep_log_error \ "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." kill -- -$WSREP_SST_OPT_PARENT sleep 1 exit 32 fi if [ ! -r "$MAGIC_FILE" ]; then # This message should cause joiner to abort: wsrep_log_info "rsync process ended without creating" \ "magic file ($MAGIC_FILE)" exit 32 fi if [ -n "$MY_SECRET" ]; then # Check donor supplied secret: SECRET=$(grep -m1 -E "^$SECRET_TAG[[:space:]]" "$MAGIC_FILE" || :) SECRET=$(trim_string "${SECRET#$SECRET_TAG}") if [ "$SECRET" != "$MY_SECRET" ]; then wsrep_log_error "Donor does not know my secret!" wsrep_log_info "Donor: '$SECRET', my: '$MY_SECRET'" exit 32 fi fi if [ $WSREP_SST_OPT_BYPASS -eq 0 ]; then if grep -m1 -qE "^$BYPASS_TAG([[:space:]]+.*)?\$" "$MAGIC_FILE"; then readonly WSREP_SST_OPT_BYPASS=1 readonly WSREP_TRANSFER_TYPE='IST' fi fi binlog_tar_present=0 if [ -f "$BINLOG_TAR_FILE" ]; then binlog_tar_present=1 if [ $WSREP_SST_OPT_BYPASS -ne 0 ]; then wsrep_log_warning "tar with binlogs transferred in the IST mode" fi fi if [ $WSREP_SST_OPT_BYPASS -eq 0 -a -n "$WSREP_SST_OPT_BINLOG" ]; then # If it is SST (not an IST) or tar with binlogs is present # among the transferred files, then we need to remove the # old binlogs: cd "$DATA" # Clean up the old binlog files and index: binlog_index="$WSREP_SST_OPT_BINLOG_INDEX" if [ -f "$binlog_index" ]; then while read bin_file || [ -n "$bin_file" ]; do rm -f "$bin_file" || : done < "$binlog_index" rm "$binlog_index" fi binlog_cd=0 # Change the directory to binlog base (if possible): if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ "$binlog_dir" != "$DATA_DIR" -a -d "$binlog_dir" ] then binlog_cd=1 cd "$binlog_dir" fi # Clean up unindexed binlog files: rm -f "$binlog_base".[0-9]* || : [ $binlog_cd -ne 0 ] && cd "$DATA_DIR" if [ $binlog_tar_present -ne 0 ]; then # Create a temporary file: tmpdir=$(parse_cnf '--mysqld|sst' 'tmpdir') if [ -z "$tmpdir" ]; then tmpfile="$(mktemp)" elif [ "$OS" = 'Linux' ]; then tmpfile=$(mktemp "--tmpdir=$tmpdir") else tmpfile=$(TMPDIR="$tmpdir"; mktemp) fi index_dir=$(dirname "$binlog_index"); if [ -n "$index_dir" -a "$index_dir" != '.' -a \ "$index_dir" != "$DATA_DIR" ] then [ ! -d "$index_dir" ] && mkdir -p "$index_dir" fi binlog_cd=0 if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ "$binlog_dir" != "$DATA_DIR" ] then [ ! -d "$binlog_dir" ] && mkdir -p "$binlog_dir" binlog_cd=1 cd "$binlog_dir" fi # Extracting binlog files: wsrep_log_info "Extracting binlog files:" if tar --version 2>/dev/null | grep -qw -E '^bsdtar'; then tar -tf "$BINLOG_TAR_FILE" > "$tmpfile" && \ tar -xvf "$BINLOG_TAR_FILE" > /dev/null || RC=$? else tar -xvf "$BINLOG_TAR_FILE" > "$tmpfile" && \ cat "$tmpfile" >&2 || RC=$? fi if [ $RC -ne 0 ]; then wsrep_log_error "Error unpacking tar file with binlog files" rm "$tmpfile" exit 32 fi # Rebuild binlog index: [ $binlog_cd -ne 0 ] && cd "$DATA_DIR" while read bin_file || [ -n "$bin_file" ]; do echo "$binlog_dir${binlog_dir:+/}$bin_file" >> "$binlog_index" done < "$tmpfile" rm "$tmpfile" cd "$OLD_PWD" fi fi simulate_long_sst # Remove special tags from the magic file, and from the output: coords=$(head -n1 "$MAGIC_FILE") wsrep_log_info "Galera co-ords from recovery: $coords" echo "$coords" # Output : UUID:seqno wsrep_gtid_domain_id fi wsrep_log_info "$WSREP_METHOD $WSREP_TRANSFER_TYPE completed on $WSREP_SST_OPT_ROLE" exit 0
[+]
..
[-] pip3.9
[edit]
[-] newgidmap
[edit]
[-] forever
[edit]
[-] sg_zone
[edit]
[-] gml2gv
[edit]
[-] stream
[edit]
[-] which
[edit]
[-] gpgparsemail
[edit]
[-] delv
[edit]
[-] mdb_copy
[edit]
[-] doveadm
[edit]
[-] msgcmp
[edit]
[-] rview
[edit]
[-] mailx.s-nail
[edit]
[-] mysqlimport
[edit]
[-] krb5-config
[edit]
[-] rpmdb
[edit]
[-] wc
[edit]
[-] find-repos-of-install
[edit]
[-] hb-ot-shape-closure
[edit]
[-] gcc-ranlib
[edit]
[-] gpg-error-config
[edit]
[-] cmsutil
[edit]
[-] myisampack
[edit]
[-] dpkg-split
[edit]
[-] powernow-k8-decode
[edit]
[-] semodule_expand
[edit]
[-] sieve-test
[edit]
[-] ea-php81-pecl
[edit]
[-] msgmerge
[edit]
[-] ping
[edit]
[-] gdbus-codegen
[edit]
[-] tload
[edit]
[-] ldd
[edit]
[-] nl-class-add
[edit]
[-] dumpkeys
[edit]
[-] whoami
[edit]
[-] nl-class-list
[edit]
[-] galera_new_cluster
[edit]
[-] msgunfmt
[edit]
[-] wmf2svg
[edit]
[-] systemd-inhibit
[edit]
[-] autoheader
[edit]
[-] seq
[edit]
[-] sg_raw
[edit]
[-] ul
[edit]
[-] captoinfo
[edit]
[-] lsipc
[edit]
[-] tail
[edit]
[-] btattach
[edit]
[-] gneqn
[edit]
[-] nmtui-hostname
[edit]
[-] lastcomm
[edit]
[-] blkrawverify
[edit]
[-] command
[edit]
[-] sccmap
[edit]
[-] yes
[edit]
[-] dnf-3
[edit]
[-] sg_compare_and_write
[edit]
[-] neato
[edit]
[-] mysql_upgrade
[edit]
[-] sg_logs
[edit]
[-] sg_unmap
[edit]
[-] pkexec
[edit]
[-] grub2-mkpasswd-pbkdf2
[edit]
[-] mysql_plugin
[edit]
[-] pkttyagent
[edit]
[-] pkla-admin-identities
[edit]
[-] imunify-antivirus
[edit]
[-] login
[edit]
[-] aria_read_log
[edit]
[-] lsiio
[edit]
[-] pic
[edit]
[-] vlock
[edit]
[-] gslj
[edit]
[-] modulemd-validator
[edit]
[-] mandb
[edit]
[-] teamdctl
[edit]
[-] fg
[edit]
[-] mariadb-fix-extensions
[edit]
[-] defncopy
[edit]
[-] clear
[edit]
[-] sg
[edit]
[-] tac
[edit]
[-] dotty
[edit]
[-] gpio-watch
[edit]
[-] rpcinfo
[edit]
[-] update-crypto-policies
[edit]
[-] utmpdump
[edit]
[-] grub2-fstest
[edit]
[-] msgcomm
[edit]
[-] btmon
[edit]
[-] dnsdomainname
[edit]
[-] wireplumber
[edit]
[-] systemd-run
[edit]
[-] nl-neightbl-list
[edit]
[-] pydoc
[edit]
[-] zforce
[edit]
[-] sg_start
[edit]
[-] whiptail
[edit]
[-] expr
[edit]
[-] pipewire-aes67
[edit]
[-] bond2team
[edit]
[-] unxz
[edit]
[-] sg_seek
[edit]
[-] osinfo-detect
[edit]
[-] sg_persist
[edit]
[-] readlink
[edit]
[-] Mail
[edit]
[-] pipewire-pulse
[edit]
[-] printenv
[edit]
[-] mysql_secure_installation
[edit]
[-] lto-dump
[edit]
[-] grub2-mklayout
[edit]
[-] ssh-copy-id
[edit]
[-] hb-subset
[edit]
[-] links
[edit]
[-] gtk-update-icon-cache
[edit]
[-] mountpoint
[edit]
[-] sg_sat_set_features
[edit]
[-] xdg-dbus-proxy
[edit]
[-] grep
[edit]
[-] package-cleanup
[edit]
[-] hb-view
[edit]
[-] cmp
[edit]
[-] sg_safte
[edit]
[-] nl-link-list
[edit]
[-] ipcrm
[edit]
[-] ausyscall
[edit]
[-] resolveip
[edit]
[-] named-rrchecker
[edit]
[-] cpan
[edit]
[-] runcon
[edit]
[-] fprintd-delete
[edit]
[-] nl-route-list
[edit]
[-] dir
[edit]
[-] nisdomainname
[edit]
[-] gxl2dot
[edit]
[-] edgepaint
[edit]
[-] systemd-cat
[edit]
[-] rmdir
[edit]
[-] ps2pdf12
[edit]
[-] libtoolize
[edit]
[-] mysql_fix_extensions
[edit]
[-] nl-addr-add
[edit]
[-] mpstat
[edit]
[-] sg_read_attr
[edit]
[-] ptar
[edit]
[-] update-ca-trust
[edit]
[-] fc-cat
[edit]
[-] keyctl
[edit]
[-] nice
[edit]
[-] sqlite3
[edit]
[-] sg_sat_identify
[edit]
[-] chcat
[edit]
[-] sg_reassign
[edit]
[-] wsrep_sst_mariabackup
[edit]
[-] scp
[edit]
[-] lastlog
[edit]
[-] systemd-stdio-bridge
[edit]
[-] getkeycodes
[edit]
[-] osinfo-query
[edit]
[-] aria_dump_log
[edit]
[-] c++
[edit]
[-] nf-exp-add
[edit]
[-] xdg-email
[edit]
[-] aria_ftdump
[edit]
[-] signver
[edit]
[-] fc-cache
[edit]
[-] doveconf
[edit]
[-] ca-legacy
[edit]
[-] uapi
[edit]
[-] dpkg-divert
[edit]
[-] dwp
[edit]
[-] repotrack
[edit]
[-] page_owner_sort
[edit]
[-] echo
[edit]
[-] flatpak
[edit]
[-] git-upload-pack
[edit]
[-] slencheck
[edit]
[-] yumdownloader
[edit]
[-] pm2-docker
[edit]
[-] systemd-machine-id-setup
[edit]
[-] innochecksum
[edit]
[-] lsgpio
[edit]
[-] sha1sum
[edit]
[-] eject
[edit]
[-] grub2-mkimage
[edit]
[-] gsettings
[edit]
[-] myisamchk
[edit]
[-] imunify-agent-proxy
[edit]
[-] slabinfo
[edit]
[-] pk12util
[edit]
[-] setup-nsssysinit.sh
[edit]
[-] gpasswd
[edit]
[-] sgp_dd
[edit]
[-] simc_lsmplugin
[edit]
[-] pftp
[edit]
[-] msggrep
[edit]
[-] col
[edit]
[-] ea-php81-pear
[edit]
[-] composite
[edit]
[-] unshare
[edit]
[-] zcat
[edit]
[-] tic
[edit]
[-] php
[edit]
[-] gio-querymodules-64
[edit]
[-] trust
[edit]
[-] mkfontdir
[edit]
[-] nl-classid-lookup
[edit]
[-] identify
[edit]
[-] nss-policy-check
[edit]
[-] lsmem
[edit]
[-] html2text
[edit]
[-] rpmverify
[edit]
[-] unix2mac
[edit]
[-] wmf2fig
[edit]
[-] zipdetails
[edit]
[-] tapestat
[edit]
[-] reposync
[edit]
[-] perl5.32.1
[edit]
[-] piconv
[edit]
[-] gdk-pixbuf-query-loaders-64
[edit]
[-] scl
[edit]
[-] mpris-proxy
[edit]
[-] getfattr
[edit]
[-] bc
[edit]
[-] nf-queue
[edit]
[-] hostid
[edit]
[-] sg_read_buffer
[edit]
[-] write
[edit]
[-] zipnote
[edit]
[-] msgfilter
[edit]
[-] dbus-uuidgen
[edit]
[-] msguniq
[edit]
[-] xdg-icon-resource
[edit]
[-] sg_sat_read_gplog
[edit]
[-] linux32
[edit]
[-] gvpack
[edit]
[-] nmtui-connect
[edit]
[-] rpmquery
[edit]
[-] nl
[edit]
[-] gpg-card
[edit]
[-] psfgettable
[edit]
[-] fc-pattern
[edit]
[-] cal
[edit]
[-] blkparse
[edit]
[-] wsrep_sst_rsync
[edit]
[-] dijkstra
[edit]
[-] batch
[edit]
[-] arch
[edit]
[-] cpapi2
[edit]
[-] nl-class-delete
[edit]
[-] perlbug
[edit]
[-] view
[edit]
[-] cyrusbdb2current
[edit]
[-] gnroff
[edit]
[-] symlinks
[edit]
[-] systemd-detect-virt
[edit]
[-] zipcloak
[edit]
[-] mariadb-import
[edit]
[-] false
[edit]
[-] npx
[edit]
[-] sadf
[edit]
[-] aspell
[edit]
[-] vdoforcerebuild
[edit]
[-] systemd-id128
[edit]
[-] perlthanks
[edit]
[-] hostname
[edit]
[-] setfacl
[edit]
[-] chardetect
[edit]
[-] audit2allow
[edit]
[-] linux64
[edit]
[-] gettext.sh
[edit]
[-] journalctl
[edit]
[-] aria_chk
[edit]
[-] setsid
[edit]
[-] mysqlslap
[edit]
[-] quota
[edit]
[-] dtrace
[edit]
[-] ld.bfd
[edit]
[-] update-desktop-database
[edit]
[-] nf-ct-list
[edit]
[-] cxpm
[edit]
[-] usleep
[edit]
[-] ranlib
[edit]
[-] showkey
[edit]
[-] pydoc3
[edit]
[-] xdg-desktop-icon
[edit]
[-] recode-sr-latin
[edit]
[-] im360-k8s-syncer
[edit]
[-] spell
[edit]
[-] sftp
[edit]
[-] setkeycodes
[edit]
[-] gtk-launch
[edit]
[-] sg_timestamp
[edit]
[-] red
[edit]
[-] sg_ses_microcode
[edit]
[-] renew-dummy-cert
[edit]
[-] xgettext
[edit]
[-] bashbug-64
[edit]
[-] mariadb-tzinfo-to-sql
[edit]
[-] sha224sum
[edit]
[-] mount
[edit]
[-] pip-3.9
[edit]
[-] mac2unix
[edit]
[-] pcre-config
[edit]
[-] mariadb-plugin
[edit]
[-] nail
[edit]
[-] brotli
[edit]
[-] ea-php81
[edit]
[-] xzgrep
[edit]
[-] objdump
[edit]
[-] gv2gxl
[edit]
[-] nl-cls-list
[edit]
[-] pinfo
[edit]
[-] hunspell
[edit]
[-] sleep
[edit]
[-] zip
[edit]
[-] yum-debug-restore
[edit]
[-] jq
[edit]
[-] protoc-gen-c
[edit]
[-] gdbm_dump
[edit]
[-] chown
[edit]
[-] osinfo-db-validate
[edit]
[-] ima-setup
[edit]
[-] ptx
[edit]
[-] fc-match
[edit]
[-] soelim
[edit]
[-] repo-graph
[edit]
[-] size
[edit]
[-] scriptlive
[edit]
[-] nl-neigh-list
[edit]
[-] df
[edit]
[-] gcov
[edit]
[-] kernel-install
[edit]
[-] pango-list
[edit]
[-] sg_dd
[edit]
[-] setmetamode
[edit]
[-] envml
[edit]
[-] id
[edit]
[-] icu-config
[edit]
[-] ar
[edit]
[-] pl2pm
[edit]
[-] kbdinfo
[edit]
[-] lsblk
[edit]
[-] soelim.groff
[edit]
[-] notify-send
[edit]
[-] aclocal
[edit]
[-] sha256sum
[edit]
[-] mmdblookup
[edit]
[-] preconv
[edit]
[-] conjure
[edit]
[-] xzfgrep
[edit]
[-] systemd-firstboot
[edit]
[-] pngfix
[edit]
[-] p11-kit
[edit]
[-] mariadb-dump
[edit]
[-] yum-config-manager
[edit]
[-] garbd
[edit]
[-] aserver
[edit]
[-] odbc_config
[edit]
[-] python3
[edit]
[-] bg
[edit]
[-] catchsegv
[edit]
[-] elinks
[edit]
[-] zmore
[edit]
[-] xslt-config
[edit]
[-] type
[edit]
[-] lchfn
[edit]
[-] x86_64-redhat-linux-gcc
[edit]
[-] lwp-dump
[edit]
[-] uname
[edit]
[-] wall
[edit]
[-] sg_sync
[edit]
[-] bunzip2
[edit]
[-] lsscsi
[edit]
[-] factor
[edit]
[-] pango-view
[edit]
[-] strace-log-merge
[edit]
[-] pre-grohtml
[edit]
[-] glib-genmarshal
[edit]
[-] ghostscript
[edit]
[-] run-parts
[edit]
[-] bash
[edit]
[-] hostnamectl
[edit]
[-] isosize
[edit]
[-] tdspool
[edit]
[-] pphs
[edit]
[-] nl-qdisc-add
[edit]
[-] gdbus
[edit]
[-] appstream-util
[edit]
[-] kdumpctl
[edit]
[-] bwrap
[edit]
[-] busctl
[edit]
[-] rev
[edit]
[-] namei
[edit]
[-] btrecord
[edit]
[-] md5sum
[edit]
[-] dbus-monitor
[edit]
[-] sha224hmac
[edit]
[-] nmtui-edit
[edit]
[-] lexgrog
[edit]
[-] gdbm_load
[edit]
[-] verify_blkparse
[edit]
[-] yum
[edit]
[-] gvmap.sh
[edit]
[-] certutil
[edit]
[-] iusql
[edit]
[-] bluetoothctl
[edit]
[-] sg_get_config
[edit]
[-] mariadb-hotcopy
[edit]
[-] mariadb-waitpid
[edit]
[-] strip
[edit]
[-] systemd-umount
[edit]
[-] usb-devices
[edit]
[-] gs
[edit]
[-] resizecons
[edit]
[-] nl-route-delete
[edit]
[-] gpgsplit
[edit]
[-] python3-config
[edit]
[-] centrino-decode
[edit]
[-] mysql_find_rows
[edit]
[-] pure-pwconvert
[edit]
[-] mysql_embedded
[edit]
[-] sg_write_x
[edit]
[-] ptargrep
[edit]
[-] wget
[edit]
[-] tmpwatch
[edit]
[-] json_reformat
[edit]
[-] bzfgrep
[edit]
[-] mogrify
[edit]
[-] animate
[edit]
[-] unix2dos
[edit]
[-] rvi
[edit]
[-] w
[edit]
[-] nl-link-name2ifindex
[edit]
[-] getconf
[edit]
[-] gr2fonttest
[edit]
[-] truncate
[edit]
[-] repomanage
[edit]
[-] column
[edit]
[-] authselect
[edit]
[-] bzdiff
[edit]
[-] fuse2fs
[edit]
[-] nl-addr-list
[edit]
[-] nm
[edit]
[-] gencat
[edit]
[-] split
[edit]
[-] funzip
[edit]
[-] scriptreplay
[edit]
[-] gzip
[edit]
[-] msgfmt.py
[edit]
[-] gpgrt-config
[edit]
[-] mytop
[edit]
[-] ndptool
[edit]
[-] nl-nh-list
[edit]
[-] sg_bg_ctl
[edit]
[-] vdodumpconfig
[edit]
[-] psfstriptable
[edit]
[-] pm2-runtime
[edit]
[-] glib-mkenums
[edit]
[-] sg_test_rwbuf
[edit]
[-] unflatten
[edit]
[-] canberra-boot
[edit]
[-] checkpolicy
[edit]
[-] blkiomon
[edit]
[-] unzip
[edit]
[-] udevadm
[edit]
[-] sestatus
[edit]
[-] zone2sql
[edit]
[-] mdb_dump
[edit]
[-] clockdiff
[edit]
[-] import
[edit]
[-] linux-boot-prober
[edit]
[-] choom
[edit]
[-] sh
[edit]
[-] g++
[edit]
[-] ea-php84
[edit]
[-] plymouth
[edit]
[-] yat2m
[edit]
[-] info
[edit]
[-] sgm_dd
[edit]
[-] toe
[edit]
[-] zdump
[edit]
[-] appstream-compose
[edit]
[-] mariadb-find-rows
[edit]
[-] intel-speed-select
[edit]
[-] sievec
[edit]
[-] modutil
[edit]
[-] pm2
[edit]
[-] montage
[edit]
[-] dpkg-deb
[edit]
[-] libwmf-fontmap
[edit]
[-] sg_write_long
[edit]
[-] zdiff
[edit]
[-] vimtutor
[edit]
[-] grub2-syslinux2cfg
[edit]
[-] tmon
[edit]
[-] sg_write_buffer
[edit]
[-] dbus-update-activation-environment
[edit]
[-] python-config
[edit]
[-] pr
[edit]
[-] xsltproc
[edit]
[-] pkgconf
[edit]
[-] mysqlhotcopy
[edit]
[-] ps2pdf
[edit]
[-] update-mime-database
[edit]
[-] mariadb-binlog
[edit]
[-] acyclic
[edit]
[-] lwp-download
[edit]
[-] mysql_install_db
[edit]
[-] checkmodule
[edit]
[-] msginit
[edit]
[-] gslp
[edit]
[-] find
[edit]
[-] fincore
[edit]
[-] dirmngr
[edit]
[-] sha384hmac
[edit]
[-] file
[edit]
[-] automake-1.16
[edit]
[-] python3.9
[edit]
[-] pflags
[edit]
[-] grub2-mkrescue
[edit]
[-] blktrace
[edit]
[-] zfgrep
[edit]
[-] ea-php84-pecl
[edit]
[-] dbiprof
[edit]
[-] rnano
[edit]
[-] logname
[edit]
[-] mcookie
[edit]
[-] fips-mode-setup
[edit]
[-] mysql_convert_table_format
[edit]
[-] gcov-dump
[edit]
[-] libpng16-config
[edit]
[-] autoconf
[edit]
[-] ps2pdf14
[edit]
[-] bzgrep
[edit]
[-] flock
[edit]
[-] printafm
[edit]
[-] autoupdate
[edit]
[-] pm2-dev
[edit]
[-] cifsiostat
[edit]
[-] tee
[edit]
[-] python-html2text
[edit]
[-] wsrep_sst_mysqldump
[edit]
[-] sync
[edit]
[-] myisamlog
[edit]
[-] cksum
[edit]
[-] sudoreplay
[edit]
[-] rsvg-convert
[edit]
[-] gawk
[edit]
[-] systemd-repart
[edit]
[-] bzcat
[edit]
[-] unalias
[edit]
[-] users
[edit]
[-] systemd-tmpfiles
[edit]
[-] gcc-ar
[edit]
[-] nmcli
[edit]
[-] shuf
[edit]
[-] lastb
[edit]
[-] myisam_ftdump
[edit]
[-] sotruss
[edit]
[-] cpupower
[edit]
[-] aria_pack
[edit]
[-] encguess
[edit]
[-] pdf2ps
[edit]
[-] slabtop
[edit]
[-] libnetcfg
[edit]
[-] ld.gold
[edit]
[-] colcrt
[edit]
[-] xzcat
[edit]
[-] xzegrep
[edit]
[-] gpgv
[edit]
[-] man-recode
[edit]
[-] chfn
[edit]
[-] gcc
[edit]
[-] lesspipe.sh
[edit]
[-] lsphp
[edit]
[-] pf2afm
[edit]
[-] autom4te
[edit]
[-] freebcp
[edit]
[-] sg_map
[edit]
[-] grub2-glue-efi
[edit]
[-] traceroute
[edit]
[-] ps2pdf13
[edit]
[-] gtester
[edit]
[-] perl
[edit]
[-] prezip
[edit]
[-] cpansign
[edit]
[-] crc32
[edit]
[-] autoscan
[edit]
[-] pod2html
[edit]
[-] lslocks
[edit]
[-] grub2-render-label
[edit]
[-] free
[edit]
[-] unlink
[edit]
[-] msgconv
[edit]
[-] systemd-ask-password
[edit]
[-] sg_rdac
[edit]
[-] c89
[edit]
[-] podchecker
[edit]
[-] h2ph
[edit]
[-] catman
[edit]
[-] debuginfod-find
[edit]
[-] cc
[edit]
[-] mkfontscale
[edit]
[-] sss_ssh_knownhostsproxy
[edit]
[-] sprof
[edit]
[-] grub2-mknetdir
[edit]
[-] enc2xs
[edit]
[-] zone2json
[edit]
[-] unzipsfx
[edit]
[-] od
[edit]
[-] protoc
[edit]
[-] circo
[edit]
[-] dpkg-statoverride
[edit]
[-] ncat
[edit]
[-] freetype-config
[edit]
[-] mdb_load
[edit]
[-] nm-online
[edit]
[-] locate
[edit]
[-] hb-shape
[edit]
[-] make
[edit]
[-] cpan-mirrors
[edit]
[-] systemd-mount
[edit]
[-] flex++
[edit]
[-] mariadb
[edit]
[-] nano
[edit]
[-] osage
[edit]
[-] pathchk
[edit]
[-] install
[edit]
[-] look
[edit]
[-] grub2-script-check
[edit]
[-] systemctl
[edit]
[-] nf-exp-delete
[edit]
[-] systemd-dissect
[edit]
[-] time
[edit]
[-] mailx
[edit]
[-] taskset
[edit]
[-] renice
[edit]
[-] xsubpp
[edit]
[-] sg_vpd
[edit]
[-] mail
[edit]
[-] pipewire
[edit]
[-] isql
[edit]
[-] fc
[edit]
[-] semodule_unpackage
[edit]
[-] uniq
[edit]
[-] hexdump
[edit]
[-] eps2eps
[edit]
[-] tset
[edit]
[-] stat
[edit]
[-] nsenter
[edit]
[-] csplit
[edit]
[-] datacopy
[edit]
[-] sudo
[edit]
[-] systemd-escape
[edit]
[-] ssh-keygen
[edit]
[-] garb-systemd
[edit]
[-] gpgconf
[edit]
[-] nl-link-release
[edit]
[-] eqn
[edit]
[-] gc
[edit]
[-] sum
[edit]
[-] sss_ssh_authorizedkeys
[edit]
[-] firewall-cmd
[edit]
[-] icu-config-64
[edit]
[-] xzmore
[edit]
[-] genl-ctrl-list
[edit]
[-] nl-fib-lookup
[edit]
[-] splain
[edit]
[-] nl-list-caches
[edit]
[-] secon
[edit]
[-] sw-engine
[edit]
[-] flatpak-coredumpctl
[edit]
[-] mariadb-dumpslow
[edit]
[-] autoreconf
[edit]
[-] iptc
[edit]
[-] bison
[edit]
[-] mv
[edit]
[-] xxd
[edit]
[-] lsmd
[edit]
[-] x86_64-redhat-linux-gcc-11
[edit]
[-] icuinfo
[edit]
[-] sdiff
[edit]
[-] nohup
[edit]
[-] prune
[edit]
[-] cronnext
[edit]
[-] dc
[edit]
[-] umask
[edit]
[-] xdg-desktop-menu
[edit]
[-] usbhid-dump
[edit]
[-] sha512sum
[edit]
[-] chronyc
[edit]
[-] ulockmgr_server
[edit]
[-] systemd-sysext
[edit]
[-] gcov-tool
[edit]
[-] sg_ident
[edit]
[-] python
[edit]
[-] ssh-keyscan
[edit]
[-] pcre2-config
[edit]
[-] head
[edit]
[-] realpath
[edit]
[-] mariadbd-multi
[edit]
[-] infotocap
[edit]
[-] httxt2dbm
[edit]
[-] findmnt
[edit]
[-] nroff
[edit]
[-] chvt
[edit]
[-] tracepath
[edit]
[-] scsi_ready
[edit]
[-] setpriv
[edit]
[-] cpp
[edit]
[-] host
[edit]
[-] dconf
[edit]
[-] systemd-analyze
[edit]
[-] mysqlaccess
[edit]
[-] diff
[edit]
[-] lsusb
[edit]
[-] dnstap-read
[edit]
[-] coredumpctl
[edit]
[-] troff
[edit]
[-] groff
[edit]
[-] logger
[edit]
[-] gdk-pixbuf-thumbnailer
[edit]
[-] xdg-settings
[edit]
[-] pinky
[edit]
[-] imunify360-command-wrapper
[edit]
[-] ifnames
[edit]
[-] sg_rmsn
[edit]
[-] ea-wappspector
[edit]
[-] canberra-gtk-play
[edit]
[-] lsattr
[edit]
[-] nmtui
[edit]
[-] htdbm
[edit]
[-] sg_emc_trespass
[edit]
[-] fc-query
[edit]
[-] exiv2
[edit]
[-] neqn
[edit]
[-] i386
[edit]
[-] fdp
[edit]
[-] sort
[edit]
[-] fmt
[edit]
[-] gpg-connect-agent
[edit]
[-] team2bond
[edit]
[-] setfattr
[edit]
[-] fold
[edit]
[-] lex
[edit]
[-] firewall-offline-cmd
[edit]
[-] sha384sum
[edit]
[-] git
[edit]
[-] pygettext.py
[edit]
[-] newgrp
[edit]
[-] repodiff
[edit]
[-] man
[edit]
[-] pip3
[edit]
[-] yum-debug-dump
[edit]
[-] infocmp
[edit]
[-] scsi_stop
[edit]
[-] wpctl
[edit]
[-] bootctl
[edit]
[-] sg_decode_sense
[edit]
[-] unexpand
[edit]
[-] chattr
[edit]
[-] openssl
[edit]
[-] dpkg-realpath
[edit]
[-] tsql
[edit]
[-] loadunimap
[edit]
[-] gsdj500
[edit]
[-] strace
[edit]
[-] pango-segmentation
[edit]
[-] lsof
[edit]
[-] snice
[edit]
[-] bno_plot.py
[edit]
[-] ld
[edit]
[-] sha512hmac
[edit]
[-] ulimit
[edit]
[-] gettextize
[edit]
[-] aclocal-1.16
[edit]
[-] uptime
[edit]
[-] gpgme-json
[edit]
[-] pgrep
[edit]
[-] gpgv2
[edit]
[-] semodule_link
[edit]
[-] bzcmp
[edit]
[-] ps2ascii
[edit]
[-] nl-list-sockets
[edit]
[-] 2to3
[edit]
[-] pstree
[edit]
[-] repoquery
[edit]
[-] vimdot
[edit]
[-] flex
[edit]
[-] libpng-config
[edit]
[-] gpg2
[edit]
[-] scsi_temperature
[edit]
[-] mariadb-convert-table-format
[edit]
[-] hardlink
[edit]
[-] loginctl
[edit]
[-] dnf4
[edit]
[-] mysqld_safe
[edit]
[-] nl-link-set
[edit]
[-] mariadb-slap
[edit]
[-] dircolors
[edit]
[-] sieve-dump
[edit]
[-] corepack
[edit]
[-] galera_recovery
[edit]
[-] gst-stats-1.0
[edit]
[-] crlutil
[edit]
[-] strings
[edit]
[-] streamzip
[edit]
[-] sar
[edit]
[-] pygettext3.py
[edit]
[-] yum-builddep
[edit]
[-] crb
[edit]
[-] auvirt
[edit]
[-] gpgtar
[edit]
[-] uname26
[edit]
[-] mariadb-conv
[edit]
[-] yum-groups-manager
[edit]
[-] dmesg
[edit]
[-] mariadb-upgrade
[edit]
[-] nl-route-get
[edit]
[-] pkg-config
[edit]
[-] sg_map26
[edit]
[-] fgconsole
[edit]
[-] mariadbd-safe-helper
[edit]
[-] lesskey
[edit]
[-] ngettext
[edit]
[-] zless
[edit]
[-] ps2ps2
[edit]
[-] mysql_setpermission
[edit]
[-] chage
[edit]
[-] geqn
[edit]
[-] whatis.man-db
[edit]
[-] htpasswd
[edit]
[-] autopoint
[edit]
[-] cpio
[edit]
[-] json_xs
[edit]
[-] mysqldumpslow
[edit]
[-] scsi_start
[edit]
[-] base64
[edit]
[-] pkill
[edit]
[-] mkfifo
[edit]
[-] sxpm
[edit]
[-] convert
[edit]
[-] mysqld_multi
[edit]
[-] ps2pdfwr
[edit]
[-] pw-jack
[edit]
[-] sg_sat_phy_event
[edit]
[-] at
[edit]
[-] compile_et
[edit]
[-] tabs
[edit]
[-] mariadb-admin
[edit]
[-] watch
[edit]
[-] date
[edit]
[-] ipcmk
[edit]
[-] wpexec
[edit]
[-] gvcolor
[edit]
[-] psfxtable
[edit]
[-] pdnsutil
[edit]
[-] egrep
[edit]
[-] vimdiff
[edit]
[-] xmlcatalog
[edit]
[-] nl-link-ifindex2name
[edit]
[-] awk
[edit]
[-] numfmt
[edit]
[-] pyinotify
[edit]
[-] sg_stpg
[edit]
[-] l2ping
[edit]
[-] git-receive-pack
[edit]
[-] iconv
[edit]
[-] ssh-add
[edit]
[-] ed
[edit]
[-] lsns
[edit]
[-] scl_source
[edit]
[-] fc-validate
[edit]
[-] wsrep_sst_rsync_wan
[edit]
[-] chsh
[edit]
[-] procan
[edit]
[-] display
[edit]
[-] dpkg
[edit]
[-] pwmake
[edit]
[-] ea-php80-pear
[edit]
[-] ea-php84-pear
[edit]
[-] fprintd-enroll
[edit]
[-] systemd-delta
[edit]
[-] modulecmd
[edit]
[-] gxl2gv
[edit]
[-] mariadb-setpermission
[edit]
[-] mknod
[edit]
[-] pidof
[edit]
[-] gvgen
[edit]
[-] link
[edit]
[-] gprof
[edit]
[-] znew
[edit]
[-] lneato
[edit]
[-] sfdp
[edit]
[-] systemd-socket-activate
[edit]
[-] hash
[edit]
[-] scl_enabled
[edit]
[-] fc-cache-64
[edit]
[-] instmodsh
[edit]
[-] uuidgen
[edit]
[-] mysqlbinlog
[edit]
[-] dbus-send
[edit]
[-] pfbtopfa
[edit]
[-] chgrp
[edit]
[-] xzdiff
[edit]
[-] nl-qdisc-list
[edit]
[-] dpkg-maintscript-helper
[edit]
[-] gtroff
[edit]
[-] sg_read
[edit]
[-] gst-inspect-1.0
[edit]
[-] ipcs
[edit]
[-] dpkg-trigger
[edit]
[-] gdbmtool
[edit]
[-] mdb_stat
[edit]
[-] fribidi
[edit]
[-] tbl
[edit]
[-] comm
[edit]
[-] glib-compile-schemas
[edit]
[-] word-list-compress
[edit]
[-] ab
[edit]
[-] systemd-sysusers
[edit]
[-] chcon
[edit]
[-] json_pp
[edit]
[-] turbostat
[edit]
[-] zegrep
[edit]
[-] getopts
[edit]
[-] mysqladmin
[edit]
[-] newuidmap
[edit]
[-] nf-exp-list
[edit]
[-] node
[edit]
[-] arping
[edit]
[-] ipcalc
[edit]
[-] upower
[edit]
[-] openvt
[edit]
[-] xmllint
[edit]
[-] kill
[edit]
[-] skill
[edit]
[-] python3.9-x86_64-config
[edit]
[-] setup-nsssysinit
[edit]
[-] gcc-nm
[edit]
[-] psfaddtable
[edit]
[-] needs-restarting
[edit]
[-] zipsplit
[edit]
[-] pmap
[edit]
[-] nl-util-addr
[edit]
[-] grub2-mount
[edit]
[-] btreplay
[edit]
[-] rm
[edit]
[-] fprintd-list
[edit]
[-] localedef
[edit]
[-] htdigest
[edit]
[-] sg_format
[edit]
[-] nl-tctree-list
[edit]
[-] true
[edit]
[-] nf-ct-add
[edit]
[-] bashbug
[edit]
[-] arpaname
[edit]
[-] lessecho
[edit]
[-] unpigz
[edit]
[-] zcmp
[edit]
[-] nl-qdisc-delete
[edit]
[-] ea-php83-pecl
[edit]
[-] gpic
[edit]
[-] osinfo-db-import
[edit]
[-] ccomps
[edit]
[-] xmlwf
[edit]
[-] sg_sanitize
[edit]
[-] gpg-wks-server
[edit]
[-] mariadb-show
[edit]
[-] systemd-tty-ask-password-agent
[edit]
[-] tclsh8.6
[edit]
[-] protoc-c
[edit]
[-] bzmore
[edit]
[-] run-with-aspell
[edit]
[-] lscpu
[edit]
[-] scsi_readcap
[edit]
[-] rpm2cpio
[edit]
[-] reset
[edit]
[-] bzip2
[edit]
[-] m4
[edit]
[-] gst-typefind-1.0
[edit]
[-] rpmkeys
[edit]
[-] setleds
[edit]
[-] unicode_stop
[edit]
[-] dnf
[edit]
[-] nl-route-add
[edit]
[-] addr2line
[edit]
[-] nf-monitor
[edit]
[-] png-fix-itxt
[edit]
[-] orc-bugreport
[edit]
[-] sg_reset
[edit]
[-] grotty
[edit]
[-] pipewire-avb
[edit]
[-] ea-php80-pecl
[edit]
[-] teamnl
[edit]
[-] GET
[edit]
[-] domainname
[edit]
[-] nf-ct-events
[edit]
[-] colrm
[edit]
[-] exempi
[edit]
[-] stty
[edit]
[-] vmstat
[edit]
[-] pkla-check-authorization
[edit]
[-] grub2-editenv
[edit]
[-] zgrep
[edit]
[-] ncurses6-config
[edit]
[-] flatpak-bisect
[edit]
[-] sg_copy_results
[edit]
[-] gpg-wks-client
[edit]
[-] msgfmt
[edit]
[-] tree
[edit]
[-] sg_wr_mode
[edit]
[-] shasum
[edit]
[-] ld.so
[edit]
[-] nl-link-stats
[edit]
[-] top
[edit]
[-] HEAD
[edit]
[-] envsubst
[edit]
[-] xargs
[edit]
[-] dirname
[edit]
[-] crontab
[edit]
[-] chacl
[edit]
[-] json_verify
[edit]
[-] h2xs
[edit]
[-] x86_64
[edit]
[-] imunify360-agent
[edit]
[-] tar
[edit]
[-] netstat
[edit]
[-] perldoc
[edit]
[-] sedispol
[edit]
[-] curl
[edit]
[-] tput
[edit]
[-] pod2man
[edit]
[-] ex
[edit]
[-] ea-php83-pear
[edit]
[-] dig
[edit]
[-] cat
[edit]
[-] getfacl
[edit]
[-] pidstat
[edit]
[-] osql
[edit]
[-] msgexec
[edit]
[-] vdosetuuid
[edit]
[-] manpath
[edit]
[-] bootconfig
[edit]
[-] bluemoon
[edit]
[-] luac
[edit]
[-] corelist
[edit]
[-] pdf2dsc
[edit]
[-] setterm
[edit]
[-] nf-log
[edit]
[-] sim_lsmplugin
[edit]
[-] osinfo-db-path
[edit]
[-] localectl
[edit]
[-] sg_rtpg
[edit]
[-] ea-php83
[edit]
[-] idiag-socket-details
[edit]
[-] sg_luns
[edit]
[-] msgfmt3.9.py
[edit]
[-] less
[edit]
[-] fc-scan
[edit]
[-] test
[edit]
[-] pigz
[edit]
[-] filan
[edit]
[-] pip
[edit]
[-] grub2-file
[edit]
[-] quotasync
[edit]
[-] rsync
[edit]
[-] mariadb-embedded
[edit]
[-] sg_verify
[edit]
[-] mkdir
[edit]
[-] dwz
[edit]
[-] alias
[edit]
[-] stdbuf
[edit]
[-] pwdx
[edit]
[-] automake
[edit]
[-] patchwork
[edit]
[-] grub2-mkrelpath
[edit]
[-] pydoc3.9
[edit]
[-] jobs
[edit]
[-] grub2-mkfont
[edit]
[-] gresource
[edit]
[-] gvpr
[edit]
[-] sg_stream_ctl
[edit]
[-] msgattrib
[edit]
[-] sieve-filter
[edit]
[-] script
[edit]
[-] wsrep_sst_backup
[edit]
[-] xml2-config
[edit]
[-] expand
[edit]
[-] tred
[edit]
[-] sg_write_same
[edit]
[-] xdg-mime
[edit]
[-] getent
[edit]
[-] killall
[edit]
[-] watchgnupg
[edit]
[-] iio_generic_buffer
[edit]
[-] vdir
[edit]
[-] gsoelim
[edit]
[-] cp
[edit]
[-] sg_reset_wp
[edit]
[-] systemd-cgls
[edit]
[-] sg_referrals
[edit]
[-] fc-list
[edit]
[-] base32
[edit]
[-] lua
[edit]
[-] bzless
[edit]
[-] xzless
[edit]
[-] patch
[edit]
[-] mariadb_config
[edit]
[-] b2sum
[edit]
[-] glib-compile-resources
[edit]
[-] systemd-cryptenroll
[edit]
[-] ea-php82
[edit]
[-] basename
[edit]
[-] gtk-query-immodules-2.0-64
[edit]
[-] unicode_start
[edit]
[-] sg_xcopy
[edit]
[-] objcopy
[edit]
[-] nsupdate
[edit]
[-] scsi-rescan
[edit]
[-] nl-addr-delete
[edit]
[-] tzselect
[edit]
[-] event_rpcgen.py
[edit]
[-] post-grohtml
[edit]
[-] mariadb-config
[edit]
[-] mysqlshow
[edit]
[-] perlml
[edit]
[-] libtool
[edit]
[-] gsnd
[edit]
[-] mariadb-service-convert
[edit]
[-] gtester-report
[edit]
[-] nc
[edit]
[-] touch
[edit]
[-] mariadb-check
[edit]
[-] shred
[edit]
[-] dbus-broker
[edit]
[-] mdig
[edit]
[-] dbilogstrip
[edit]
[-] perlivp
[edit]
[-] gzexe
[edit]
[-] graphml2gv
[edit]
[-] gmake
[edit]
[-] tsort
[edit]
[-] peekfd
[edit]
[-] env
[edit]
[-] grub2-mkstandalone
[edit]
[-] distro
[edit]
[-] iio_event_monitor
[edit]
[-] odbcinst
[edit]
[-] gunzip
[edit]
[-] nproc
[edit]
[-] lsinitrd
[edit]
[-] pwscore
[edit]
[-] xzdec
[edit]
[-] sg_rep_pip
[edit]
[-] sg_read_block_limits
[edit]
[-] ls
[edit]
[-] pure-statsdecode
[edit]
[-] kbdrate
[edit]
[-] grub2-kbdcomp
[edit]
[-] git-shell
[edit]
[-] kvm_stat
[edit]
[-] dos2unix
[edit]
[-] sg_turs
[edit]
[-] gpg
[edit]
[-] gv2gml
[edit]
[-] mysqld_safe_helper
[edit]
[-] npm
[edit]
[-] mysql_config
[edit]
[-] pip-3
[edit]
[-] gvmap
[edit]
[-] rpm
[edit]
[-] pod2usage
[edit]
[-] msgfmt3.py
[edit]
[-] nop
[edit]
[-] last
[edit]
[-] mysql
[edit]
[-] deallocvt
[edit]
[-] msql2mysql
[edit]
[-] sg_get_elem_status
[edit]
[-] pidwait
[edit]
[-] grub2-menulst2cfg
[edit]
[-] evmctl
[edit]
[-] lchsh
[edit]
[-] cd
[edit]
[-] dovecot-sysreport
[edit]
[-] aulast
[edit]
[-] groups
[edit]
[-] rescan-scsi-bus.sh
[edit]
[-] gapplication
[edit]
[-] more
[edit]
[-] bsqldb
[edit]
[-] os-prober
[edit]
[-] fc-conflist
[edit]
[-] mm2gv
[edit]
[-] prezip-bin
[edit]
[-] python3.9-config
[edit]
[-] whereis
[edit]
[-] mysqldump
[edit]
[-] make-dummy-cert
[edit]
[-] precat
[edit]
[-] imunify-fgw-dump
[edit]
[-] systemd-hwdb
[edit]
[-] read
[edit]
[-] dot2gxl
[edit]
[-] tclsh
[edit]
[-] pldd
[edit]
[-] [
[edit]
[-] gio
[edit]
[-] btmgmt
[edit]
[-] man.man-db
[edit]
[-] bzegrep
[edit]
[-] POST
[edit]
[-] scsi_mandat
[edit]
[-] x86_energy_perf_policy
[edit]
[-] rvim
[edit]
[-] sed
[edit]
[-] scsi_satl
[edit]
[-] fallocate
[edit]
[-] nl-rule-list
[edit]
[-] updatedb
[edit]
[-] setvtrgb
[edit]
[-] paperconf
[edit]
[-] osinfo-db-export
[edit]
[-] lsirq
[edit]
[-] resolve_stack_dump
[edit]
[-] sg_rep_zones
[edit]
[-] ispell
[edit]
[-] lwp-mirror
[edit]
[-] sginfo
[edit]
[-] glib-gettextize
[edit]
[-] gsf-office-thumbnailer
[edit]
[-] desktop-file-validate
[edit]
[-] diff3
[edit]
[-] cut
[edit]
[-] osinfo-install-script
[edit]
[-] s-nail
[edit]
[-] chrt
[edit]
[-] systemd-creds
[edit]
[-] ypdomainname
[edit]
[-] sg_read_long
[edit]
[-] bzip2recover
[edit]
[-] tr
[edit]
[-] passwd
[edit]
[-] gsdj
[edit]
[-] lslogins
[edit]
[-] fisql
[edit]
[-] mysql_waitpid
[edit]
[-] xdg-screensaver
[edit]
[-] gsbj
[edit]
[-] bcomps
[edit]
[-] perror
[edit]
[-] ln
[edit]
[-] ps2epsi
[edit]
[-] msgen
[edit]
[-] nslookup
[edit]
[-] grops
[edit]
[-] atrm
[edit]
[-] basenc
[edit]
[-] atq
[edit]
[-] prlimit
[edit]
[-] ps2ps
[edit]
[-] zsoelim
[edit]
[-] semodule_package
[edit]
[-] sm3hmac
[edit]
[-] sg_inq
[edit]
[-] nl-cls-delete
[edit]
[-] sg_rbuf
[edit]
[-] teamd
[edit]
[-] btrace
[edit]
[-] who
[edit]
[-] gtar
[edit]
[-] audit2why
[edit]
[-] dracut
[edit]
[-] ptardiff
[edit]
[-] kmod
[edit]
[-] apropos
[edit]
[-] gtk-query-immodules-3.0-64
[edit]
[-] join
[edit]
[-] tracker3
[edit]
[-] sg_write_verify
[edit]
[-] gpio-event-mon
[edit]
[-] pslog
[edit]
[-] socat
[edit]
[-] prove
[edit]
[-] systemd-path
[edit]
[-] sg_opcodes
[edit]
[-] sg_ses
[edit]
[-] mesg
[edit]
[-] dbus-broker-launch
[edit]
[-] timedatectl
[edit]
[-] xzcmp
[edit]
[-] setfont
[edit]
[-] nl-pktloc-lookup
[edit]
[-] ssh-agent
[edit]
[-] sha256hmac
[edit]
[-] xdg-open
[edit]
[-] aulastlog
[edit]
[-] printf
[edit]
[-] nl-cls-add
[edit]
[-] ncursesw6-config
[edit]
[-] apropos.man-db
[edit]
[-] elfedit
[edit]
[-] gpg-error
[edit]
[-] mapscrn
[edit]
[-] tcptraceroute
[edit]
[-] update-gtk-immodules
[edit]
[-] debuginfo-install
[edit]
[-] cvtsudoers
[edit]
[-] su
[edit]
[-] iostat
[edit]
[-] sg_scan
[edit]
[-] vdodmeventd
[edit]
[-] pdns_control
[edit]
[-] mktemp
[edit]
[-] dd
[edit]
[-] mariadb-access
[edit]
[-] msgcat
[edit]
[-] umount
[edit]
[-] dpkg-query
[edit]
[-] du
[edit]
[-] chmem
[edit]
[-] sg_readcap
[edit]
[-] zipgrep
[edit]
[-] c99
[edit]
[-] sg_modes
[edit]
[-] ea-php80
[edit]
[-] prtstat
[edit]
[-] fusermount
[edit]
[-] wdctl
[edit]
[-] imunify-service
[edit]
[-] vim
[edit]
[-] gpio-hammer
[edit]
[-] gobject-query
[edit]
[-] dot
[edit]
[-] showconsolefont
[edit]
[-] rename
[edit]
[-] nl-monitor
[edit]
[-] wsrep_sst_common
[edit]
[-] traceroute6
[edit]
[-] mariadb-secure-installation
[edit]
[-] cpapi1
[edit]
[-] x86_64-redhat-linux-gnu-pkg-config
[edit]
[-] cpapi3
[edit]
[-] ea-php82-pear
[edit]
[-] rpcbind
[edit]
[-] paste
[edit]
[-] readelf
[edit]
[-] x86_64-redhat-linux-c++
[edit]
[-] sg_prevent
[edit]
[-] replace
[edit]
[-] gst-launch-1.0
[edit]
[-] dltest
[edit]
[-] pure-pw
[edit]
[-] ps
[edit]
[-] my_print_defaults
[edit]
[-] git-upload-archive
[edit]
[-] chmod
[edit]
[-] systemd-notify
[edit]
[-] systemd-cgtop
[edit]
[-] nl-link-enslave
[edit]
[-] bsqlodbc
[edit]
[-] loadkeys
[edit]
[-] twopi
[edit]
[-] timeout
[edit]
[-] desktop-file-install
[edit]
[-] xz
[edit]
[-] irqtop
[edit]
[-] pipewire-vulkan
[edit]
[-] hex2hcd
[edit]
[-] mariadb-install-db
[edit]
[-] diffimg
[edit]
[-] preunzip
[edit]
[-] getopt
[edit]
[-] whatis
[edit]
[-] uuidparse
[edit]
[-] ea-php82-pecl
[edit]
[-] locale
[edit]
[-] repoclosure
[edit]
[-] pkcheck
[edit]
[-] mysql_tzinfo_to_sql
[edit]
[-] compare
[edit]
[-] cluster
[edit]
[-] vi
[edit]
[-] gtbl
[edit]
[-] sedismod
[edit]
[-] fips-finish-install
[edit]
[-] pwd
[edit]
[-] tty
[edit]
[-] avinfo
[edit]
[-] lsusb.py
[edit]
[-] sha1hmac
[edit]
[-] setarch
[edit]
[-] dirmngr-client
[edit]
[-] ssltap
[edit]
[-] logresolve
[edit]
[-] btt
[edit]
[-] sg_senddiag
[edit]
[-] nl-neigh-delete
[edit]
[-] c++filt
[edit]
[-] ima-add-sigs
[edit]
[-] ssh
[edit]
[-] rsync-ssl
[edit]
[-] sudoedit
[edit]
[-] pstree.x11
[edit]
[-] gettext
[edit]
[-] sg_get_lba_status
[edit]
[-] wmf2x
[edit]
[-] pygettext3.9.py
[edit]
[-] sg_requests
[edit]
[-] mariadbd-safe
[edit]
[-] config_data
[edit]
[-] rpm2archive
[edit]
[-] lwp-request
[edit]
[-] kbd_mode
[edit]
[-] zipinfo
[edit]
[-] lefty
[edit]
[-] fgrep
[edit]
[-] x86_64-redhat-linux-g++
[edit]
[-] pathfix3.9.py
[edit]
[-] wait
[edit]
[-] pathfix.py
[edit]
[-] ionice
[edit]
[-] vdoformat
[edit]
[-] vdostats
[edit]
[-] as
[edit]
[-] python3-html2text
[edit]
[-] desktop-file-edit
[edit]
[-] attr
[edit]
[-] ac
[edit]
[-] scsi_logging_level
[edit]
[-] wmf2eps
[edit]
[-] pkaction
[edit]
[-] idn
[edit]
[-] g13
[edit]
[-] fprintd-verify
[edit]
[-] gpg-agent
[edit]
[-] lsmcli
[edit]
[-] wmf2gd
[edit]
[-] pod2text
[edit]
[-] ftp
[edit]
[-] nl-neigh-add
[edit]
[-] mysqlcheck
[edit]